commit 3feea217fcc1d08e8542ef458ada3b4983ac17ba
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Aug 24 16:18:32 2020 +0100

    libstdc++: Add deduction guide for std::ranges::join_view [LWG 3474]
    
    This implements the proposed resolution for LWG 3474.
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ranges (join_view): Add deduction guide (LWG 3474).
            * testsuite/std/ranges/adaptors/join_lwg3474.cc: New test.
    
    (cherry picked from commit ef275d1f2083f8a1fa1b59a3cd07fd3e8431023e)

diff --git a/libstdc++-v3/include/std/ranges b/libstdc++-v3/include/std/ranges
index fa58c165110..23c54b2ae4e 100644
--- a/libstdc++-v3/include/std/ranges
+++ b/libstdc++-v3/include/std/ranges
@@ -2699,6 +2699,11 @@ namespace views
   template<typename _Range>
     explicit join_view(_Range&&) -> join_view<views::all_t<_Range>>;
 
+    // _GLIBCXX_RESOLVE_LIB_DEFECTS
+    // 3474. Nesting join_views is broken because of CTAD
+  template<typename _View>
+    explicit join_view(join_view<_View>) -> join_view<join_view<_View>>;
+
   namespace views
   {
     inline constexpr __adaptor::_RangeAdaptorClosure join
diff --git a/libstdc++-v3/testsuite/std/ranges/adaptors/join_lwg3474.cc b/libstdc++-v3/testsuite/std/ranges/adaptors/join_lwg3474.cc
new file mode 100644
index 00000000000..516aaba7070
--- /dev/null
+++ b/libstdc++-v3/testsuite/std/ranges/adaptors/join_lwg3474.cc
@@ -0,0 +1,37 @@
+// Copyright (C) 2020 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++2a" }
+// { dg-do compile { target c++2a } }
+
+#include <ranges>
+#include <vector>
+
+void
+test01()
+{
+  // LWG 3474. Nesting join_views is broken because of CTAD
+  std::vector<std::vector<std::vector<int>>> nested_vectors = {
+    {{1, 2, 3}, {4, 5}, {6}},
+    {{7},       {8, 9}, {10, 11, 12}},
+    {{13}}
+  };
+  auto joined = nested_vectors | std::views::join | std::views::join;
+
+  using V = decltype(joined);
+  static_assert( std::same_as<std::ranges::range_value_t<V>, int> );
+}

